Projects/MIUBlog/MIUBlog/MIUBlog/Controllers/BlogController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using MIUBlog.Business.Abstract;
using MIUBlog.Entities.Concrete;
using MIUBlog.Models;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace MIUBlog.WebUI.Controllers
{
    public class BlogController : Controller
    {
        private IBlogService _blogService;
        private ICategoryService _categoryService;
        private ICommentService _commentService;
        private UserManager<ApplicationUser> _userManager;
        public BlogController(IBlogService blogService, ICategoryService categoryService, ICommentService commentService, UserManager<ApplicationUser> userManager)
        {
            _blogService = blogService;
            _categoryService = categoryService;
            _commentService = commentService;
            _userManager = userManager;
        }



        public IActionResult Index(int? id, string q)
        {
            var query = _blogService.GetAll().Where(i => i.isApproved);
            if (id != null)
            {
                query = _blogService.GetAll().Where(i => i.CategoryId == id);
            }
            if (!string.IsNullOrEmpty(q))
            {
                query = query.Where(i => EF.Functions.Like(i.Title, "%" + q + "%") || i.Description.ToLower().Contains(q.ToLower()) || i.Body.ToLower().Contains(q.ToLower()));
            }
            return View(query.OrderByDescending(i => i.Date));
        }
        [Authorize(Roles = "Admin")]
        public IActionResult List()
        {
            return View(_blogService.GetAll());
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");

            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create(Blog entity)
        {
            TempData["action"] = "Create";


            if (ModelState.IsValid)
            {
                ApplicationUser user = await _userManager.FindByNameAsync(User.Identity.Name);
                entity.ApplicationUserId = user.Id;
                _blogService.Add(entity);
                return RedirectToAction("List");
            }
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");
            return View(entity);
        }
        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Edit(int id)
        {
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");

            return View(_blogService.GetAll().Where(i => i.BlogId == id).FirstOrDefault());

        }

        public IActionResult Details(int id, Blog blg)
        {
            int blogId = id;
            if (id == 0)
            {
                blogId = blg.BlogId;
            }


            var blog = _blogService.Get(blogId);
            var comments = _commentService.GetAll()
                .Include(i => i.ApplicationUser)
                .Where(i => i.Blog.BlogId == blogId && i.isApproved == true);
            BlogModel model = new BlogModel()
            {
                Blog = blog,
                Comments = comments
            };
            return View(model);
        }
        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(Blog entity, IFormFile file)
        {
            if (ModelState.IsValid)
            {
                if (file != null)
                {
                    var path = Path.Combine(Directory.GetCurrentDirectory(), "wwwroot/img", file.FileName);
                    using (var stream = new FileStream(path, FileMode.Create))
                    {
                        await file.CopyToAsync(stream);
                    }
                    entity.Image = file.FileName;
                }


                _blogService.Update(entity);
                TempData["message"] = $"{entity.Title} güncellendi.";
                return RedirectToAction("List");
            }
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");
            return View(entity);
        }
        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Delete(int id)
        {
            var result = _blogService.GetAll().Where(i => i.BlogId == id).FirstOrDefault();
            TempData["message"] = $"{result.Title } Silmek İstediğinizden Eminmisiniz";


            return View(result);
        }
        [HttpPost, ActionName("Delete")]
        [Authorize(Roles = "Admin")]
        public IActionResult DeleteConfirmate(int BlogId)
        {
            try
            {
                var result = _blogService.GetAll().Where(i => i.BlogId == BlogId).FirstOrDefault();
                TempData["message"] = $"{result.Title} Silindi";
                if (ModelState.IsValid)
                {
                    _blogService.Delete(BlogId);

                }

                return RedirectToAction("List");
            }
            catch (DbUpdateException e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = "Önce alt kayıtları silmelisiniz.";
                return View("Error", errorViewModel);
            }
            catch (Exception e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = e.Message;
                return View("Error", errorViewModel);
            }
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddOrUpdate(int? id)
        {

            if (id == 0 || id == null)
            {

                ViewData["title"] = "Create";
                TempData["action"] = "Create";
                return View("Create");
            }
            else
            {
                TempData["action"] = "Update";
                ViewData["title"] = "Update";
                return View("Create", _blogService.GetAll().FirstOrDefault(i => i.BlogId == id));

            }


        }
        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task< IActionResult> AddOrUpdate(Blog entity, IFormFile file)
        {
            if (entity.BlogId == 0)
            {
                if (file != null)
                {
                    var path = Path.Combine(Directory.GetCurrentDirectory(), "wwwroot/img", file.FileName);
                    using (var stream = new FileStream(path, FileMode.Create))
                    {
                        await file.CopyToAsync(stream);
                    }
                    entity.Image = file.FileName;
                }
                ApplicationUser user = await _userManager.FindByNameAsync(User.Identity.Name);
                entity.ApplicationUserId = user.Id;

                _blogService.Add(entity);
                ViewData["title"] = "Create";
                TempData["action"] = "Create";
                return RedirectToAction("List");
            }
            else
            {
                _blogService.Update(entity);
                ViewData["title"] = "Update";
                TempData["action"] = "Update";
                return RedirectToAction("List");
            }


        }
    }

}

Projects/MIUBlog/MIUBlog/MIUBlog/Controllers/DiscussionController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using MIUBlog.Business.Abstract;
using MIUBlog.Entities.Concrete;
using MIUBlog.Models;
using MIUBlog.WebUI.Models;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace MIUDiscussion.WebUI.Controllers
{
    public class DiscussionController : Controller
    {
        private IDiscussionService _discussionService;
        private ICategoryService _categoryService;
        private ICommentService _commentService;
        private UserManager<ApplicationUser> _userManager;
        public DiscussionController(IDiscussionService discussionService, ICategoryService categoryService, ICommentService commentService, UserManager<ApplicationUser> userManager)
        {
            _discussionService = discussionService;
            _categoryService = categoryService;
            _commentService = commentService;
            _userManager = userManager;
        }



        public IActionResult Index()
        {
            var query = _discussionService.GetAll().Where(i => i.isApproved);
           
            return View(query.OrderByDescending(i => i.Date));
        }
        [Authorize(Roles = "Admin")]
        public IActionResult List()
        {
            return View(_discussionService.GetAll());
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");

            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create(Discussion entity)
        {
            TempData["action"] = "Create";


            if (ModelState.IsValid)
            {
                ApplicationUser user = await _userManager.FindByNameAsync(User.Identity.Name);
                entity.ApplicationUserId = user.Id;
                _discussionService.Add(entity);
                return RedirectToAction("List");
            }
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");
            return View(entity);
        }
        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Edit(int id)
        {
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");

            return View(_discussionService.GetAll().Where(i => i.Id == id).FirstOrDefault());

        }

        public IActionResult Details(int id, Discussion blg)
        {
            int discussionId = id;
            if (id == 0)
            {
                discussionId = blg.Id;
            }


            var discussion = _discussionService.Get(discussionId);
            var comments = _commentService.GetAll()
                .Include(i => i.ApplicationUser)
                .Where(i => i.Discussion.Id == discussionId && i.isApproved == true);
            DiscussionModel model = new DiscussionModel()
            {
                Discussion = discussion,
                Comments = comments
            };
            return View(model);
        }
        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(Discussion entity, IFormFile file)
        {
            if (ModelState.IsValid)
            {
                if (file != null)
                {
                    var path = Path.Combine(Directory.GetCurrentDirectory(), "wwwroot/img", file.FileName);
                    using (var stream = new FileStream(path, FileMode.Create))
                    {
                        await file.CopyToAsync(stream);
                    }
                    entity.Image = file.FileName;
                }


                _discussionService.Update(entity);
                TempData["message"] = $"{entity.Title} güncellendi.";
                return RedirectToAction("List");
            }
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");
            return View(entity);
        }
        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Delete(int id)
        {
            var result = _discussionService.GetAll().Where(i => i.Id == id).FirstOrDefault();
            TempData["message"] = $"{result.Title } Silmek İstediğinizden Eminmisiniz";


            return View(result);
        }
        [HttpPost, ActionName("Delete")]
        [Authorize(Roles = "Admin")]
        public IActionResult DeleteConfirmate(int DiscussionId)
        {
            try
            {
                var result = _discussionService.GetAll().Where(i => i.Id == DiscussionId).FirstOrDefault();
                TempData["message"] = $"{result.Title} Silindi";
                if (ModelState.IsValid)
                {
                    _discussionService.Delete(DiscussionId);

                }

                return RedirectToAction("List");
            }
            catch (DbUpdateException e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = "Önce alt kayıtları silmelisiniz.";
                return View("Error", errorViewModel);
            }
            catch (Exception e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = e.Message;
                return View("Error", errorViewModel);
            }
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddOrUpdate(int? id)
        {

            if (id == 0 || id == null)
            {

                ViewData["title"] = "Create";
                TempData["action"] = "Create";
                return View("Create");
            }
            else
            {
                TempData["action"] = "Update";
                ViewData["title"] = "Update";
                return View("Create", _discussionService.GetAll().FirstOrDefault(i => i.Id == id));

            }


        }
        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> AddOrUpdate(Discussion entity, IFormFile file)
        {
            if (entity.Id == 0)
            {
                ApplicationUser user = await _userManager.FindByNameAsync(User.Identity.Name);
                entity.ApplicationUserId = user.Id;
                if (file != null)
                {
                    var path = Path.Combine(Directory.GetCurrentDirectory(), "wwwroot/img", file.FileName);
                    using (var stream = new FileStream(path, FileMode.Create))
                    {
                        await file.CopyToAsync(stream);
                    }
                    entity.Image = file.FileName;
                }

                _discussionService.Add(entity);
                ViewData["title"] = "Create";
                TempData["action"] = "Create";
                return RedirectToAction("List");
            }
            else
            {
                _discussionService.Update(entity);
                ViewData["title"] = "Update";
                TempData["action"] = "Update";
                return RedirectToAction("List");
            }


        }
    }
}

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Discussion/Create.cshtml
@model Discussion

@section scripts{

    <script src="~/modules/ckeditor/ckeditor.js"></script>
    <script>
        CKEDITOR.replace("Body")
    </script>
}
<div class="container">
    <div class="bg-primary text-white p-1 m-1 text-center">
        <h2>Create Discussion </h2>
    </div>

    <div class="bg-danger" asp-validation-summary="All"></div>
    <form asp-controller="Discussion" asp-action="AddOrUpdate" method="post">
        <input type="hidden" asp-for="Id" />
        <input type="hidden" asp-for="Image" />
        <div class="form-group">
            <label asp-for="Title"></label>
            <input asp-for="Title" class="form-control">
        </div>
        <div class="form-group">
            <label asp-for="Description"></label>
            <textarea asp-for="Description" class="form-control"></textarea>
        </div>
        <div class="form-group">
            <label asp-for="Body"></label>
            <textarea asp-for="Body" class="form-control"></textarea>
        </div>
        <input type="hidden" value="@DateTime.Now" asp-for="Date" />
        <div class="form-group">
            <label asp-for="CategoryId"> Category Name</label>
            <select class="form-control" asp-for="CategoryId" asp-items="ViewBag.Categories">
                <option disabled selected value="">Select Category</option>
            </select>
        </div>
        <div class="form-group">
            
            <input type="file" name="file" id="file" class="form-control">
        </div>
        <button type="submit" class="btn btn-primary">Submit</button>
        <a class="btn btn-secondary" asp-controller="Blog" asp-action="List">Cancel</a>
    </form>

</div>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Discussion/Delete.cshtml
@model Discussion

@{
    ViewData["Title"] = "Delete";
}
<div class="container">
    <div class="bg-primary text-white p-1 m-1 text-center">
        <h2>Blog Delete</h2>
    </div>
    <div class="bg-danger" asp-validation-summary="All"></div>
    <form asp-action="Delete" method="post" asp-controller="Discussion">
        <input type="hidden" asp-for="Id" />
        <button type="submit" class="btn btn-danger">Delete</button>
        <a class="btn btn-secondary" asp-controller="Blog" asp-action="List">Cancel</a>
    </form>
</div>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Discussion/Details.cshtml
@model   MIUBlog.WebUI.Models.DiscussionModel
@{
    ViewData["Title"] = "Details";
}

<div class="container mt-3">
    <div class="row">
        <div class="col-md-3">
            @await Component.InvokeAsync("Categories")
        </div>
        <div class="col-md-9">
            <div class="card mb-2">
                <img class="card-img-top" src="~/img/@Model.Discussion.Image" alt="Card image cap">

                <div class="card-block">
                    <br />
                    <h3 class="card-title text-left" style="display:inline-block;">@Model.Discussion.Title</h3><br />
                    <p class="card-title text-right" style="display:inline-block;"><i class="far fa-user-circle"></i>&nbsp; @Model.Discussion.ApplicationUser.NormalizedUserName</p>
                    <p class="card-text">@Model.Discussion.Description</p>
                    <p class="card-text">@Html.Raw(Model.Discussion.Body)</p>
                    <h5> Yorumlar </h5>
                    @if (Model.Comments.Count() == 0)
                    {
                        <p> Bu tartışmaya ilgiliz henüz yorum yapılmamış</p>
                    }
                    else
                    {
                        @foreach (var comment in Model.Comments)
                        {

                            <div class="card">
                                <div class="card-header">
                                    <span style="display:inline-block" class="text-left"> @comment.ApplicationUser.NormalizedUserName</span>
                                    <span style="display:inline-block" class="text-right"> @comment.Date </span>
                                </div>
                                <div class="card-body">
                                    <blockquote class="blockquote mb-0">
                                        <p>@comment.CommentText</p>

                                    </blockquote>
                                </div>
                            </div>






                        }
                    }

                    @if (User.Identity.IsAuthenticated)
                    {

                        <form method="post" asp-action="CreateDiscussionComment" asp-route-discussionId="@Model.Discussion.Id" asp-controller="Comment">
                            <div class="card">
                                <div class="card-header">
                                    <h3 class="font-weight-bold">Yorum yap</h3>
                                </div>
                                <div class="card-body">
                                    <blockquote class="blockquote mb-0">

                                        <textarea class="form-control" name="commentText" id="commentText" placeholder="Username" aria-label="Username">
                                            
                                        </textarea>

                                        <button type="submit" class="btn mt-1 btn-outline-secondary rounded-pill mt-1">Gönder</button>
                                    </blockquote>
                                </div>
                            </div>



                        </form>

                    }
                    else
                    {
                        <div class="form-control">
                            <input class="form-control" disabled="disabled" placeholder="Yorum yapmak için üye olunuz" aria-label="Yorum yapmak için üye olunuz" />


                        </div>
                        <a class="btn btn-outline-secondary rounded-pill mt-1" onclick="getMessage()"> Gönder </a>

                    }

                </div>

            </div>
        </div>
    </div>

</div>

<script>
    function getMessage() {
        alert("Yorum Yapmak İçin Lütfen Üye Olunuz");
    }
</script>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Discussion/Edit.cshtml
@model Discussion

@section scripts{

    <script src="~/modules/ckeditor/ckeditor.js"></script>
    <script>
        CKEDITOR.replace("Body")
    </script>
}



<div class="container">
    <div class="bg-primary text-white p-1 m-1 text-center">
        <h2>Update Discussion </h2>
    </div>
    <div class="bg-danger" asp-validation-summary="All"></div>
    <form asp-controller="Discussion" asp-action="Edit" method="post" enctype="multipart/form-data">
        <input type="hidden" asp-for="Id" />
        <input type="hidden" asp-for="Image" />
        <div class="form-group">
            <label asp-for="Title"></label>
            <input asp-for="Title" class="form-control">
        </div>

        <div class="form-group">
            <label asp-for="Description"></label>
            <textarea asp-for="Description" class="form-control"></textarea>
        </div>

        <div class="form-group">
            <label asp-for="Body"></label>
            <textarea asp-for="Body" class="form-control"></textarea>
        </div>

        <div class="form-group">
            <img src="~/img/@Model.Image" width="120" />
            <input type="file" name="file" id="file" class="form-control">
        </div>
        <div class="form-group">
            <div class="form-check">
                <label asp-for="isApproved" class="form-check-label">
                    <input asp-for="isApproved" class="form-check-input">
                    is Approved
                </label>
            </div>
        </div>
        

        <input type="hidden" value="@Model.Date" asp-for="Date" />
        <div class="form-group">
            <label asp-for="CategoryId">Category Name</label>
            <select class="form-control" asp-for="CategoryId" asp-items="ViewBag.Categories">
                <option disabled selected value="">Select Category</option>
            </select>
        </div>
        <input type="hidden" asp-for="@Model.ApplicationUserId"/>

        <button type="submit" class="btn btn-primary">Submit</button>
        <a class="btn btn-secondary" asp-controller="Blog" asp-action="List">Cancel</a>
    </form>

</div>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Discussion/Index.cshtml
@model IEnumerable<Discussion>
@{
    ViewData["Title"] = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<!DOCTYPE html>
<html>
<head>
    <style>
        .card {
            -webkit-border-radius: 10px;
            border-radius: 10px;
            -moz-border-radius: 10px;
            transition: box-shadow 1s;
        }

            .card:hover {
                -webkit-box-shadow: 5px 10px #888888;
                -moz-box-shadow: 5px 10px #888888;
                box-shadow: 5px 10px #888888;
            }

        .updt-btn:hover {
            color: white;
        }

        /* .card > img {
                height: 250px;
            }*/
    </style>
</head>
<body>


    <div class="container mt-2">
        <div class="row">
            <div class="col-md-3">
                @await Component.InvokeAsync("Categories")
            </div>
            <div class="col-md-9">

                @await Html.PartialAsync("_DiscussionList", Model)


            </div>
        </div>
    </div>
    </body>
</html>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Discussion/List.cshtml
@model IEnumerable<Discussion>

@{
    ViewData["Title"] = "List";
}
@section Css
{
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.20/css/dataTables.bootstrap4.min.css">
}

@section Scripts
{
    <script src="//cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.20/js/dataTables.bootstrap4.min.js"></script>

    <script>
        $(document).ready( function () {
            $('#myTable').DataTable();
        });
    </script>

}


<div class="container mt-3">
    <div class="bg-primary text-white p-1 m-1 text-center">
        <h2>Discussion List</h2>
    </div>
    <a asp-action="Create" asp-controller="Discussion" class="btn btn-primary mb-3">Create</a>
    <br />
    <div class="row">
        <div class="col">
            @if (Model.Count() > 0)
            {
                <table data-page-length='3' id="myTable" class="table table-bordered table-striped mt-3">
                  
                        <thead>
                            <tr>
                                <th>Id</th>
                                <th>Image</th>
                                <th>Title</th>
                                <th>Date</th>
                                <th>is Approved</th>
                               
                                <th></th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var item in Model)
                            {
                                <tr>
                                    <td>@item.Id</td>
                                    <td>
                                        <img src="~/img/@item.Image" width="100" />
                                    </td>
                                    <td>@item.Title</td>
                                    <td>@item.Date</td>
                                    <td>
                                        @if (item.isApproved)
                                        {
                                            <i class="fa fa-check" aria-hidden="true"></i>
                                        }
                                        else
                                        {
                                            <i class="fa fa-times" aria-hidden="true"></i>
                                        }
                                    </td>
                                   
                                  
                                    <td>
                                        <a class="btn btn-warning btn-sm" asp-controller="Discussion" asp-action="Edit" asp-route-id="@item.Id">
                                            Update
                                        </a>
                                        <a class="btn btn-danger btn-sm" asp-controller="Discussion" asp-action="Delete" asp-route-id="@item.Id">
                                            Delete
                                        </a>
                                    </td>
                                </tr>
                            }
                        </tbody>
                    </table>
                    }
                    else
                    {
                    <div class="alert alert-danger">
                        Tartışma Eklenmemiş.
                    </div>
                    }

            </div>
    </div>
</div>